UIPackage
Menu

Framework

Change language

Boilerplate repo

Slider

sliderui

Single-thumb slider — pick a value within a range. Optional tick marks, step size, and inline value display.

Also available for React ->

Installation

$npx shadcn-vue@latest add https://uipkge.dev/r/vue/slider.json
Named registry:npx shadcn-vue@latest add @uipkge/sliderInstalls to:app/components/ui/slider/

Examples

Loading interactive previews…

Props

NameType / ValuesDefaultRequired
classHTMLAttributes['class']optional
modelValuenumber | number[] | [number, number] | null | undefinedoptional
defaultValuenumber | number[] | [number, number] | null | undefinedoptional
range

Enable dual-thumb range selection

booleanoptional
vertical

Vertical orientation

booleanoptional
height

Height when vertical (px or css value)

string | numberoptional
marks

Tick marks with labels

Record<number, string | SliderMark>optional
tooltip

Show tooltip on drag/focus. Boolean or formatter function

boolean | ((value: number)optional

Schema

Type aliases from this item's source — use them to shape the data you pass in.

SliderMark
interface SliderMark {
  label: string
  style?: Record<string, string>
}

npm dependencies

Used by

Files installed (2)

  • app/components/ui/slider/Slider.vue10.8 kB
    <script setup lang="ts">
    import type { SliderRootProps } from 'reka-ui'
    import type { HTMLAttributes } from 'vue'
    import { computed, ref, watch } from 'vue'
    import { reactiveOmit } from '@vueuse/core'
    import {
      SliderRange,
      SliderRoot,
      SliderThumb,
      SliderTrack,
      TooltipArrow,
      TooltipContent,
      TooltipPortal,
      TooltipProvider,
      TooltipRoot,
      TooltipTrigger,
    } from 'reka-ui'
    import { cn } from '@/lib/utils'
    
    export interface SliderMark {
      label: string
      style?: Record<string, string>
    }
    
    type ModelValue = number | number[] | [number, number] | null | undefined
    
    const props = withDefaults(
      defineProps<
        Omit<SliderRootProps, 'modelValue' | 'defaultValue' | 'inverted'> & {
          class?: HTMLAttributes['class']
          modelValue?: ModelValue
          defaultValue?: ModelValue
          /** Enable dual-thumb range selection */
          range?: boolean
          /** Vertical orientation */
          vertical?: boolean
          /** Height when vertical (px or css value) */
          height?: string | number
          /** Tick marks with labels */
          marks?: Record<number, string | SliderMark>
          /** Show tooltip on drag/focus. Boolean or formatter function */
          tooltip?: boolean | ((value: number) => string)
          /** Show dots at each step */
          dots?: boolean
          /** Reverse direction (right-to-left or bottom-to-top) */
          reverse?: boolean
          /** Highlight the track between thumbs/min (default true) */
          included?: boolean
          /** Size variant */
          size?: 'small' | 'default'
        }
      >(),
      {
        min: 0,
        max: 100,
        step: 1,
        included: true,
        size: 'default',
        tooltip: true,
      },
    )
    
    const emits = defineEmits<{
      'update:modelValue': [value: number | number[] | [number, number]]
      valueCommit: [payload: number | number[] | [number, number]]
    }>()
    
    /* ── normalize value to number[] for Reka UI ── */
    const innerValue = ref<number[]>([])
    
    watch(
      () => props.modelValue,
      (v) => {
        const dflt = props.range ? [props.min, props.max] : [props.min]
        if (v == null) {
          innerValue.value = dflt
          return
        }
        if (props.range) {
          const arr = Array.isArray(v) ? v : [v, props.max]
          innerValue.value = [arr[0] ?? props.min, arr[1] ?? props.max]
        } else {
          innerValue.value = Array.isArray(v) ? v : [v]
        }
      },
      { immediate: true },
    )
    
    function handleUpdate(val: number[] | undefined) {
      if (!val) return
      innerValue.value = val
      if (props.range) {
        emits('update:modelValue', [val[0], val[1]] as [number, number])
      } else if (Array.isArray(props.modelValue)) {
        // backward-compat: consumer passed an array, emit an array
        emits('update:modelValue', val)
      } else {
        emits('update:modelValue', val[0] ?? props.min)
      }
    }
    
    function handleCommit(val: number[] | undefined) {
      if (!val) return
      if (props.range) {
        emits('valueCommit', [val[0], val[1]] as [number, number])
      } else if (Array.isArray(props.modelValue)) {
        emits('valueCommit', val)
      } else {
        emits('valueCommit', val[0] ?? props.min)
      }
    }
    
    /* ── layout helpers ── */
    const orientation = computed(() => {
      if (props.vertical) return 'vertical'
      return props.orientation ?? 'horizontal'
    })
    
    const isHorizontal = computed(() => orientation.value === 'horizontal')
    
    // Default track matches shadcn-ish h-1.5 (aligned with React).
    const trackSize = computed(() =>
      props.size === 'small' ? (isHorizontal.value ? 'h-1' : 'w-1') : isHorizontal.value ? 'h-1.5' : 'w-1.5',
    )
    
    const thumbSize = computed(() => (props.size === 'small' ? 'size-3' : 'size-4'))
    
    /* ── marks ── */
    const markList = computed(() => {
      if (!props.marks) return []
      const entries = Object.entries(props.marks).map(([key, val]) => {
        const num = Number(key)
        const label = typeof val === 'string' ? val : val.label
        const style = typeof val === 'string' ? undefined : val.style
        const pct = ((num - props.min) / (props.max - props.min)) * 100
        return { value: num, label, style, pct }
      })
      entries.sort((a, b) => a.value - b.value)
      return entries
    })
    
    /* ── step dots ── */
    const dotList = computed(() => {
      if (!props.dots) return []
      const list: number[] = []
      const count = Math.floor((props.max - props.min) / props.step)
      for (let i = 0; i <= count; i++) {
        list.push(props.min + i * props.step)
      }
      return list
    })
    
    /* ── tooltip ── */
    const showTooltip = computed(() => props.tooltip !== false)
    
    function formatTooltip(v: number) {
      if (typeof props.tooltip === 'function') return props.tooltip(v)
      return String(v)
    }
    
    /* ── delegated reka props ── */
    const delegated = reactiveOmit(
      props,
      'class',
      'modelValue',
      'defaultValue',
      'range',
      'vertical',
      'height',
      'marks',
      'tooltip',
      'dots',
      'reverse',
      'included',
      'size',
    )
    
    const rootProps = computed(() => ({
      ...delegated,
      modelValue: innerValue.value,
      orientation: orientation.value,
      inverted: props.reverse,
    }))
    </script>
    
    <template>
      <TooltipProvider>
        <div
          :class="cn('relative w-full', !isHorizontal && 'flex flex-col items-center')"
          :style="!isHorizontal && height ? { height: typeof height === 'number' ? `${height}px` : height } : undefined"
        >
          <SliderRoot
            v-slot="{ modelValue: thumbs }"
            data-uipkge
            data-slot="slider"
            :class="
              cn(
                'relative flex touch-none select-none data-[disabled]:opacity-50',
                isHorizontal ? 'w-full items-center' : 'h-full min-h-44 flex-col justify-center',
                props.class,
              )
            "
            v-bind="rootProps"
            @update:model-value="handleUpdate"
            @value-commit="handleCommit"
          >
            <!-- Track -->
            <SliderTrack
              data-uipkge
              data-slot="slider-track"
              :class="cn('bg-muted relative grow overflow-hidden rounded-full', trackSize)"
            >
              <SliderRange
                v-if="included"
                data-uipkge
                data-slot="slider-range"
                :class="cn('bg-primary absolute', isHorizontal ? 'h-full' : 'w-full')"
              />
            </SliderTrack>
    
            <!-- Step dots -->
            <template v-if="dotList.length">
              <div
                v-for="dot in dotList"
                :key="dot"
                :class="
                  cn(
                    'border-primary/40 bg-background absolute rounded-full border',
                    isHorizontal ? 'top-1/2 size-1.5 -translate-y-1/2' : 'left-1/2 size-1.5 -translate-x-1/2',
                    props.size === 'small' && 'size-1',
                  )
                "
                :style="
                  isHorizontal
                    ? {
                        left: `${((dot - min) / (max - min)) * 100}%`,
                        transform: 'translateX(-50%) translateY(-50%)',
                      }
                    : {
                        bottom: `${((dot - min) / (max - min)) * 100}%`,
                        transform: 'translateX(-50%) translateY(50%)',
                      }
                "
              />
            </template>
    
            <!-- Marks -->
            <div
              v-if="markList.length"
              :class="
                cn(
                  'pointer-events-none absolute',
                  isHorizontal ? 'top-full mt-2.5 h-5 w-full' : 'top-0 left-full ml-3 h-full w-20',
                )
              "
            >
              <span
                v-for="mark in markList"
                :key="mark.value"
                class="text-muted-foreground absolute text-xs whitespace-nowrap"
                :style="{
                  ...mark.style,
                  ...(isHorizontal
                    ? { left: `${mark.pct}%`, transform: 'translateX(-50%)' }
                    : { bottom: `${mark.pct}%`, transform: 'translateY(50%)' }),
                }"
              >
                {{ mark.label }}
              </span>
            </div>
    
            <!-- Thumbs (with tooltips) -->
            <template v-for="(_, idx) in thumbs" :key="idx">
              <TooltipRoot v-if="showTooltip" :delay-duration="0">
                <TooltipTrigger as-child>
                  <SliderThumb
                    :index="idx"
                    data-uipkge
                    data-slot="slider-thumb"
                    :class="
                      cn(
                        'border-primary bg-background ring-ring/50 block shrink-0 touch-manipulation rounded-full border shadow-sm hover:ring-4 focus-visible:ring-4 focus-visible:outline-hidden disabled:pointer-events-none disabled:opacity-50 data-[disabled]:pointer-events-none',
                        thumbSize,
                      )
                    "
                  />
                </TooltipTrigger>
                <TooltipPortal>
                  <TooltipContent
                    :side="isHorizontal ? 'top' : 'right'"
                    :side-offset="4"
                    class="bg-foreground text-background z-50 w-fit rounded-md px-2 py-1 text-xs"
                  >
                    {{ formatTooltip(thumbs?.[idx] ?? 0) }}
                    <TooltipArrow class="bg-foreground fill-foreground size-3 rotate-45 rounded-[2px]" />
                  </TooltipContent>
                </TooltipPortal>
              </TooltipRoot>
    
              <SliderThumb
                v-else
                :index="idx"
                data-uipkge
                data-slot="slider-thumb"
                :class="
                  cn(
                    'border-primary bg-background ring-ring/50 block shrink-0 touch-manipulation rounded-full border shadow-sm hover:ring-4 focus-visible:ring-4 focus-visible:outline-hidden disabled:pointer-events-none disabled:opacity-50 data-[disabled]:pointer-events-none',
                    thumbSize,
                  )
                "
              />
            </template>
          </SliderRoot>
        </div>
      </TooltipProvider>
    </template>
    
    <style>
    /*
      Subtle motion suite for slider:
      - Range fill + thumb position ease on keyboard / programmatic steps
      - Press scale on thumb (CSS `scale`, not `transform` — primitives set transform inline)
      - While the root is :active (pointer drag / track scrub), drop positional transitions so the
        thumb and fill track the pointer 1:1 with no lag
      - prefers-reduced-motion kills all of it
    */
    @media (prefers-reduced-motion: no-preference) {
      [data-slot='slider-range'] {
        transition-property: left, right, top, bottom;
        transition-duration: 150ms;
        transition-timing-function: cubic-bezier(0.16, 1, 0.3, 1);
      }
    
      [data-slot='slider-thumb'] {
        scale: 1;
        transition-property: color, box-shadow, border-color, scale, left, right, top, bottom;
        transition-duration: 150ms;
        transition-timing-function: cubic-bezier(0.16, 1, 0.3, 1);
      }
    
      [data-slot='slider-thumb']:active:not([data-disabled]) {
        scale: 0.94;
        transition-duration: 100ms;
      }
    
      /* Instant follow while pointer is down — keyboard still gets the ease above */
      [data-slot='slider']:active [data-slot='slider-range'],
      [data-slot='slider']:active [data-slot='slider-thumb'] {
        transition-property: color, box-shadow, border-color, scale;
        transition-duration: 100ms;
      }
    }
    
    @media (prefers-reduced-motion: reduce) {
      [data-slot='slider-range'],
      [data-slot='slider-thumb'] {
        transition: none !important;
        scale: 1 !important;
      }
    }
    </style>
    
  • app/components/ui/slider/index.ts0 kB

Raw manifest:https://uipkge.dev/r/vue/slider.json

UIPackage
Menu

Framework

Change language

Boilerplate repo

Slider

sliderui

Single-thumb slider — pick a value within a range. Optional tick marks, step size, and inline value display.

Also available for Vue ->

Installation

$npx shadcn@latest add https://uipkge.dev/r/react/slider.json
Named registry:npx shadcn@latest add @uipkge-react/sliderInstalls to:components/ui/slider/

Examples

Loading interactive previews…

Props

NameType / ValuesDefaultRequired
classNamestringoptional
value

Controlled value (Radix uses number[]).

number[]optional
defaultValue

Uncontrolled initial value.

number[]optional
onValueChange(value: number[]) => voidoptional
onValueCommit(value: number[]) => voidoptional
range

Enable dual-thumb range selection (affects default value when uncontrolled).

booleanoptional
vertical

Vertical orientation

booleanoptional
height

Height when vertical (px or css value)

string | numberoptional
marks

Tick marks with labels

Record<number, string | SliderMark>optional
tooltip

Show tooltip on drag/focus. Boolean or formatter function

boolean | ((value: number) => string)optional
dots

Show dots at each step

booleanoptional
reverse

Reverse direction (right-to-left or bottom-to-top)

booleanoptional
included

Highlight the track between thumbs/min (default true)

booleanoptional
size

Size variant

'small' | 'default'optional

Schema

Type aliases from this item's source — use them to shape the data you pass in.

SliderMark
interface SliderMark {
  label: string
  style?: React.CSSProperties
}

Used by

Files installed (2)

  • components/ui/slider/Slider.tsx10.3 kB
    'use client'
    
    import * as React from 'react'
    import * as SliderPrimitive from '@radix-ui/react-slider'
    import * as TooltipPrimitive from '@radix-ui/react-tooltip'
    import { cn } from '@/lib/utils'
    
    /** Injected once — mirrors Vue Slider.vue motion styles (range ease, press scale, reduced-motion). */
    const STYLE_ID = 'slider-motion-styles'
    const STYLE_CONTENT = `
    @media (prefers-reduced-motion: no-preference) {
      [data-slot='slider-range'] {
        transition-property: left, right, top, bottom;
        transition-duration: 150ms;
        transition-timing-function: cubic-bezier(0.16, 1, 0.3, 1);
      }
      [data-slot='slider-thumb'] {
        scale: 1;
        transition-property: color, box-shadow, border-color, scale, left, right, top, bottom;
        transition-duration: 150ms;
        transition-timing-function: cubic-bezier(0.16, 1, 0.3, 1);
      }
      [data-slot='slider-thumb']:active:not([data-disabled]) {
        scale: 0.94;
        transition-duration: 100ms;
      }
      [data-slot='slider']:active [data-slot='slider-range'],
      [data-slot='slider']:active [data-slot='slider-thumb'] {
        transition-property: color, box-shadow, border-color, scale;
        transition-duration: 100ms;
      }
    }
    @media (prefers-reduced-motion: reduce) {
      [data-slot='slider-range'],
      [data-slot='slider-thumb'] {
        transition: none !important;
        scale: 1 !important;
      }
    }
    `
    
    export interface SliderMark {
      label: string
      style?: React.CSSProperties
    }
    
    export interface SliderProps extends Omit<
      React.ComponentPropsWithoutRef<typeof SliderPrimitive.Root>,
      'value' | 'defaultValue' | 'inverted' | 'orientation' | 'onValueChange' | 'onValueCommit'
    > {
      className?: string
      /** Controlled value (Radix uses number[]). */
      value?: number[]
      /** Uncontrolled initial value. */
      defaultValue?: number[]
      onValueChange?: (value: number[]) => void
      onValueCommit?: (value: number[]) => void
      /** Enable dual-thumb range selection (affects default value when uncontrolled). */
      range?: boolean
      /** Vertical orientation */
      vertical?: boolean
      /** Height when vertical (px or css value) */
      height?: string | number
      /** Tick marks with labels */
      marks?: Record<number, string | SliderMark>
      /** Show tooltip on drag/focus. Boolean or formatter function */
      tooltip?: boolean | ((value: number) => string)
      /** Show dots at each step */
      dots?: boolean
      /** Reverse direction (right-to-left or bottom-to-top) */
      reverse?: boolean
      /** Highlight the track between thumbs/min (default true) */
      included?: boolean
      /** Size variant */
      size?: 'small' | 'default'
    }
    
    const Slider = React.forwardRef<React.ElementRef<typeof SliderPrimitive.Root>, SliderProps>(
      (
        {
          className,
          value,
          defaultValue,
          onValueChange,
          onValueCommit,
          min = 0,
          max = 100,
          step = 1,
          range = false,
          vertical = false,
          height,
          marks,
          tooltip = true,
          dots = false,
          reverse = false,
          included = true,
          size = 'default',
          ...props
        },
        ref,
      ) => {
        /* ── normalize value to number[] ── */
        const resolvedDefault = React.useMemo<number[]>(() => {
          if (defaultValue != null) return defaultValue
          return range ? [min, max] : [min]
        }, [defaultValue, range, min, max])
    
        // Track current values so tooltips/marks can read them in both controlled
        // and uncontrolled usage (Radix doesn't surface the value to children).
        const [internalValue, setInternalValue] = React.useState<number[]>(resolvedDefault)
        const isControlled = value !== undefined
        const currentValue = isControlled ? value! : internalValue
    
        const handleChange = React.useCallback(
          (next: number[]) => {
            if (!isControlled) setInternalValue(next)
            onValueChange?.(next)
          },
          [isControlled, onValueChange],
        )
    
        /* ── layout helpers ── */
        const orientation = vertical ? 'vertical' : 'horizontal'
        const isHorizontal = orientation === 'horizontal'
    
        const trackSize = size === 'small' ? (isHorizontal ? 'h-1' : 'w-1') : isHorizontal ? 'h-1.5' : 'w-1.5'
    
        const thumbSize = size === 'small' ? 'size-3' : 'size-4'
    
        /* ── marks ── */
        const markList = React.useMemo(() => {
          if (!marks) return []
          const entries = Object.entries(marks).map(([key, val]) => {
            const num = Number(key)
            const label = typeof val === 'string' ? val : val.label
            const style = typeof val === 'string' ? undefined : val.style
            const pct = ((num - min) / (max - min)) * 100
            return { value: num, label, style, pct }
          })
          entries.sort((a, b) => a.value - b.value)
          return entries
        }, [marks, min, max])
    
        /* ── step dots ── */
        const dotList = React.useMemo(() => {
          if (!dots) return []
          const list: number[] = []
          const count = Math.floor((max - min) / step)
          for (let i = 0; i <= count; i++) {
            list.push(min + i * step)
          }
          return list
        }, [dots, max, min, step])
    
        /* ── tooltip ── */
        const showTooltip = tooltip !== false
        const formatTooltip = (v: number) => (typeof tooltip === 'function' ? tooltip(v) : String(v))
    
        React.useLayoutEffect(() => {
          if (typeof document === 'undefined') return
          let el = document.getElementById(STYLE_ID) as HTMLStyleElement | null
          if (!el) {
            el = document.createElement('style')
            el.id = STYLE_ID
            document.head.appendChild(el)
          }
          if (el.textContent !== STYLE_CONTENT) el.textContent = STYLE_CONTENT
        }, [])
    
        const thumbClass = cn(
          'border-primary bg-background ring-ring/50 block shrink-0 rounded-full border shadow-sm touch-manipulation hover:ring-4 focus-visible:ring-4 focus-visible:outline-hidden disabled:pointer-events-none disabled:opacity-50 data-[disabled]:pointer-events-none',
          thumbSize,
        )
    
        return (
          <TooltipPrimitive.Provider>
            <div
              className={cn('relative w-full', !isHorizontal && 'flex flex-col items-center')}
              style={!isHorizontal && height ? { height: typeof height === 'number' ? `${height}px` : height } : undefined}
            >
              <SliderPrimitive.Root
                ref={ref}
                data-uipkge=""
                data-slot="slider"
                min={min}
                max={max}
                step={step}
                value={isControlled ? value : undefined}
                defaultValue={isControlled ? undefined : resolvedDefault}
                orientation={orientation}
                inverted={reverse}
                onValueChange={handleChange}
                onValueCommit={onValueCommit}
                className={cn(
                  'relative flex touch-none select-none data-[disabled]:opacity-50',
                  isHorizontal ? 'w-full items-center' : 'h-full min-h-44 flex-col justify-center',
                  className,
                )}
                {...props}
              >
                {/* Track */}
                <SliderPrimitive.Track
                  data-uipkge=""
                  data-slot="slider-track"
                  className={cn('bg-muted relative grow overflow-hidden rounded-full', trackSize)}
                >
                  {included && (
                    <SliderPrimitive.Range
                      data-uipkge=""
                      data-slot="slider-range"
                      className={cn('bg-primary absolute', isHorizontal ? 'h-full' : 'w-full')}
                    />
                  )}
                </SliderPrimitive.Track>
    
                {/* Step dots */}
                {dotList.map((dot) => (
                  <div
                    key={dot}
                    className={cn(
                      'border-primary/40 bg-background absolute rounded-full border',
                      isHorizontal ? 'top-1/2 size-1.5 -translate-y-1/2' : 'left-1/2 size-1.5 -translate-x-1/2',
                      size === 'small' && 'size-1',
                    )}
                    style={
                      isHorizontal
                        ? {
                            left: `${((dot - min) / (max - min)) * 100}%`,
                            transform: 'translateX(-50%) translateY(-50%)',
                          }
                        : {
                            bottom: `${((dot - min) / (max - min)) * 100}%`,
                            transform: 'translateX(-50%) translateY(50%)',
                          }
                    }
                  />
                ))}
    
                {/* Marks */}
                {markList.length > 0 && (
                  <div
                    className={cn(
                      'pointer-events-none absolute',
                      isHorizontal ? 'top-full mt-2.5 h-5 w-full' : 'top-0 left-full ml-3 h-full w-20',
                    )}
                  >
                    {markList.map((mark) => (
                      <span
                        key={mark.value}
                        className="text-muted-foreground absolute text-xs whitespace-nowrap"
                        style={{
                          ...mark.style,
                          ...(isHorizontal
                            ? { left: `${mark.pct}%`, transform: 'translateX(-50%)' }
                            : { bottom: `${mark.pct}%`, transform: 'translateY(50%)' }),
                        }}
                      >
                        {mark.label}
                      </span>
                    ))}
                  </div>
                )}
    
                {/* Thumbs (with tooltips) */}
                {currentValue.map((thumbValue, idx) =>
                  showTooltip ? (
                    <TooltipPrimitive.Root key={idx} delayDuration={0}>
                      <TooltipPrimitive.Trigger asChild>
                        <SliderPrimitive.Thumb data-uipkge="" data-slot="slider-thumb" className={thumbClass} />
                      </TooltipPrimitive.Trigger>
                      <TooltipPrimitive.Portal>
                        <TooltipPrimitive.Content
                          side={isHorizontal ? 'top' : 'right'}
                          sideOffset={4}
                          className="bg-foreground text-background z-50 w-fit rounded-md px-2 py-1 text-xs"
                        >
                          {formatTooltip(thumbValue ?? 0)}
                          <TooltipPrimitive.Arrow className="bg-foreground fill-foreground size-2.5 rotate-45 rounded-[2px]" />
                        </TooltipPrimitive.Content>
                      </TooltipPrimitive.Portal>
                    </TooltipPrimitive.Root>
                  ) : (
                    <SliderPrimitive.Thumb key={idx} data-uipkge="" data-slot="slider-thumb" className={thumbClass} />
                  ),
                )}
              </SliderPrimitive.Root>
            </div>
          </TooltipPrimitive.Provider>
        )
      },
    )
    Slider.displayName = 'Slider'
    
    export { Slider }
    
  • components/ui/slider/index.ts0.1 kB

Raw manifest:https://uipkge.dev/r/react/slider.json